part of xwidgetbase;

Widget? Three_ConcatenatedXItem<T, K>({
  required double height,
  required Axis wrapDirection,
  required double fontSizeForItem,
  required String title,
  required Color? titleColor,
  required Iterable<MapEntry<dynamic, List<T>>> items,
  required Widget Function(T) titleFirstWidget,
  required K Function(T) firstGroupListsBy,
  required dynamic Function(T) titleSecondWidget,
  required String titleSecondXItem,
  required Widget Function(T) thirdWidget,
  bool groupByForLastLevel = false, //TODO
  K Function(T)? groupListsBy_LastItems, //TODO
  Widget Function(MapEntry<K, List<T>>)? thirdWidgetForGroupBy, //TODO
  bool titleFirstOnTop = true,
  bool titleSecondOnTop = false,
  bool? borderAllAroundList,
  Color? backGroundColorTitleContainer,
  Color? colorBorderOfarea,
  Color? backGroundColor,
  Color? backGroundColorFirstXItem,
  Color? backGroundColorSecondXItem,
  double? titleContainerHeight,
  double? fontSizeForTitleOfArea,
  double? widthFirstXItem,
  double? widthSecondXItem,
  double? titleFirstContainerWidth,
  double? titleSecondContainerWidth,
  Axis? firstWrapDirection,
  Axis? secondWrapDirection,
  Axis? thirdWrapDirection,
  MapEntry<dynamic, List<T>>? titleFirstWidgetForGroupBy,
}) {
  var xi = XItem(
      title: title,
      titleColor: colorBorderOfarea ?? Colors.white,
      titleOnTop: true,
      titleBackGroundColor: backGroundColorTitleContainer ?? null,
      titleContainerHeight: titleContainerHeight ?? 40,
      titleWidthBorder: 5,
      titleAlignOnTop: Alignment.center,
      titleContainerWidth: double.infinity,
      titleStyle: TextStyle(color: titleColor, fontSize: fontSizeForTitleOfArea ?? 24, fontWeight: FontWeight.bold),
      colorCard: backGroundColor,
      children: [
        items.length == 0
            ? XItemWidget(
                borderWidth: 5,
                titleBackColor: colorBorderOfarea ?? Colors.black,
                borderAll: borderAllAroundList ?? true,
                child: Container(
                  height: 100,
                  child: Row(children: [Expanded(child: Text("..nessuna..", textAlign: TextAlign.center, style: XStyles.xStyleText(fontSize: 30)))]),
                ))
            : XItemWidget(
                alignmentChild: Alignment.topLeft,
                heightChildContainer: height,
                borderWidth: 5,
                titleBackColor: colorBorderOfarea ?? Colors.black,
                child: Wrap(
                    spacing: 1,
                    runSpacing: 6,
                    direction: wrapDirection,
                    //1ST GRP - DATA ANNO
                    children: items.map((grp1) {
                      var xii = XItem(
                          wrapDirection: firstWrapDirection ?? Axis.vertical,
                          width: widthFirstXItem ?? 400,
                          height: null,
                          wrapSpacing: 1,
                          wrapRunSpacing: 1,
                          //1ST GROUP
                          titleWidget: grp1.value.map(titleFirstWidget).first,
                          colorCard: backGroundColorFirstXItem ?? Colors.blue.withOpacity(0.2),
                          crossAxisAlignmentXItem: CrossAxisAlignment.start,
                          mainAxisAlignmentXItem: MainAxisAlignment.start,
                          titleAlignOnTop: titleFirstOnTop != false ? Alignment.centerLeft : null,
                          titleContainerWidth: titleFirstOnTop != false ? double.infinity - 20 : titleFirstContainerWidth ?? 80,
                          titleOnTop: titleFirstOnTop,
                          titleStyle: TextStyle(color: colorBorderOfarea ?? titleColor, fontSize: 20),
                          // 2nd GROUP
                          children: grp1.value.groupListsBy<K>(firstGroupListsBy).entries.map((grp2) {
                            return Container(
                                child: XItem(
                              wrapDirection: secondWrapDirection ?? Axis.horizontal,
                              width: widthSecondXItem ?? 200,
                              title: grp2.value.map(titleSecondWidget).first.toString(),
                              titleColor: XColors.xcolor_ForegroundLight,
                              titleAlignOnTop: titleSecondOnTop != false ? Alignment.centerLeft : null,
                              titleContainerWidth: titleSecondOnTop == false ? titleSecondContainerWidth ?? 50 : double.infinity - 20,
                              titleOnTop: titleSecondOnTop,
                              titleBackGroundColor: Colors.transparent,
                              colorCard: backGroundColorSecondXItem,
                              // 3th GROUP
                              children: [
                                XItemWidget(
                                    title: "",
                                    borderAll: true,
                                    titleBackColor: Colors.transparent,
                                    backGroundColorInternalWidget: Colors.transparent,
                                    child: Wrap(
                                      direction: thirdWrapDirection ?? Axis.horizontal,
                                      children: groupByForLastLevel == false
                                          ? grp2.value.map(thirdWidget).toList()
                                          : //
                                          grp2.value.groupListsBy<K>(groupListsBy_LastItems!).entries.map(thirdWidgetForGroupBy!).toList(),
                                    )),
                              ],
                            ));
                          }).toList());
                      return xii;
                    }).toList())),
      ]);
  return xi;
}
